<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" 
 "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<title>Error 404</title>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
</head>
<body>

<?php

/**
 *	A List Apart - The Perfect 404 
 *      http://alistapart.com/articles/perfect404/
 *
 *	Original Author  : Ian Lloyd
 *	Last Modified    : 01-21-2004
 *	
 *      Basically just a PHP conversion of Ian's Javascript
 *	
 **/

$strReferrer = strtolower($_SERVER['HTTP_REFERER']);
$blnSearchReferral = false;
$blnInsiteReferral = false;
$strSite = "";

if (strlen($strReferrer)!=0)
//we have been referred to this page some another web page ...
{
	if (
		(strpos($strReferrer,".looksmart.co") > 0) ||
		(strpos($strReferrer,".ifind.freeserve") > 0) ||
		(strpos($strReferrer,".ask.co") > 0) ||
		(strpos($strReferrer,"google.co") > 0) ||
		(strpos($strReferrer,"altavista.co") > 0) ||
		(strpos($strReferrer,"msn.co") > 0) ||
		(strpos($strReferrer,"hotbot.co") > 0) ||
		(strpos($strReferrer,"yahoo.co") > 0) )
	{
		//we have been referred to from a known search engine
		$blnSearchReferral = true;
		$arrSite = explode("/", $strReferrer);
		$arrParams = explode("?", $strReferrer);
		$strSearchTerms = $arrParams[1];
		$arrParams = explode("&", $strSearchTerms);
		$strSite = $arrSite[2];
		$sQryStr = "";
		
		//define what search terms are in use
		$arrQueryStrings[0] = "q=";	//google, altavista, msn
		$arrQueryStrings[1] = "p=";	//yahoo
		$arrQueryStrings[2] = "ask=";	//ask jeeves
		$arrQueryStrings[3] = "qt=";	//looksmart
		$arrQueryStrings[4] = "query=";	//hotbot

		for ($i=0; $i<count($arrParams); $i++)
		//loop through all the parameters in the referring page's URL
		{
			for ($q=0; $q<count($arrQueryStrings); $q++)
			{
				$sQryStr = $arrQueryStrings[$q];
				if (strpos($arrParams[$i], $sQryStr) === 0)
				//we've found a search term!
				{
					$strSearchTerms = $arrParams[$i];
					$strSearchTerms = explode($sQryStr, $strSearchTerms);
					$strSearchTerms = $strSearchTerms[1];
					$strSearchTerms = str_replace("+", " ", $strSearchTerms);
					$strSearchTerms = urldecode($strSearchTerms);
				}
			}
		}
		
		echo 
		  "<p>You did a search on <strong><a href=\"$strReferrer\">$strSite</a></strong> for "
			."<strong>$strSearchTerms</strong>. However, their index appears to be out of date.</p>\n"
			."<h2>All is not lost!</h2>\n"
			."<p>We think that the following page on our site will be able to help you:</p>\n";
			
		//--------------------------------------------------------------
		// edit and repeat for all pages you want to match to the search phrases found

		if ((strpos($strSearchTerms, "usability") !== FALSE) || (strpos($strSearchTerms, "accessibility") !== FALSE))
		{
			echo "<a href='http://www.alistapart.com/topics/usability/'>topic directory: usability</a><br />";
			echo "<a href='http://www.alistapart.com/topics/accessibility/'>topic directory: accessibility</a><br />";
		}

	//--------------------------------------------------------------
	}//end of section dealing with referral from known search engine

	if (!$blnSearchReferral)
	{
		// ------------------------------------------------
		// for referrals from other sites with broken links
		$strSite = $strReferrer;
		$strSite = explode("/", $strSite);
		$strSite = $strSite[2];
		echo "<p>You were incorrectly referred to this page by: <strong><a href=\"$strReferrer\">$strSite</a></strong><br />We suggest you try one of the links below:</p>\n";
	}

	if ($blnSearchReferral)
	{
		echo "<p>Or you could try one of the following pages:</p>\n";
	}
		echo "<p><a href=\"/\" title=\"Go to the home page for www.mysite.com\">Home Page</a>\n";
		echo "<a href=\"/site-map.php\" title=\"View the complete site map for www.mysite.com\">Site Map</a></p>\n";

	if (!$blnSearchReferral)
	{
		// for referrals from other sites with broken links
		// ------------------------------------------------
		$blnInsiteReferral = ((substr($strReferrer, "http://www.mysite.com/") >= 0) || (substr($strReferrer, "http://www.mysite2.co.uk/") >= 0) || (substr($strReferrer, "http://www.mysite3.com/") >= 0));

		$str  = "<div class=\"form\">\n";
		$str .= "<h2>Help us to help you ...</h2>\n";

		if ($blnInsiteReferral)
		{
			$str .= "<p>It looks like one of our own links is broken - we\'re very sorry about this, and we will ensure that this is passed on so that the links can be fixed. All you need to do is press the button below.</p>\n";
		}
		else
		{
			$str.="<p>In order to improve our service, you can inform us that someone else has an incorrect link to our site. We will do our best to notify them that this page has moved and ask them to update the link. <strong>Just press the button!</strong></p>";
		}
		$str.="<form method=\"post\" action=\"http://www.cutandpastescripts.com/cgi-bin/formprocessing/forms.pl\" onsubmit=\"alert('Thank you for letting us know!');\">";
		$str.="<input type=\"hidden\" name=\"activenumber\" value=\"721199347485\" />";
		$str.="<input type=\"hidden\" name=\"username\" value=\"accessify\" />";
		$str.="<input type=\"hidden\" name=\"Referring Site\" value=\"' + $strReferrer + '\" />";
		$str.="<input type=\"hidden\" name=\"Page Requested\" value=\"' + location.href + '\" />";
		$str.="<input type=\"submit\" name=\"cmdSubmit\" class=\"button\" value=\"Report this broken link &gt;&gt;\" />";
		$str.="</form>";
		$str.="</div>";
		echo $str;
	}
}

?>

</body>
</html>